import { useState } from 'react';
import { useNavContext } from './NavContext';
var useNav = function () {
    var _a = useNavContext(), location = _a.location, push = _a.push;
    var _b = useState([]), selection = _b[0], setSelection = _b[1];
    var handleExpand = function (e, item, index, stack) {
        e.preventDefault();
        setSelection([index].concat(selection));
    };
    var handleSelect = function (e, item, index, stack) {
        e.preventDefault();
        push(item.value);
        setSelection([index].concat(selection));
    };
    var handleBeforeSelect = function (e, item, index, stack) {
        if (e.button === 1) {
            e.preventDefault();
            var win = window.open("" + item.value, '_blank');
            win.focus();
        }
    };
    var handleCollapse = function (e, item) {
        e.preventDefault();
        setSelection(selection.slice(1));
    };
    var isActive = function (item) { return item.value === location.pathname; };
    return {
        handleExpand: handleExpand,
        handleSelect: handleSelect,
        handleBeforeSelect: handleBeforeSelect,
        handleCollapse: handleCollapse,
        isActive: isActive,
        selection: selection
    };
};
export default useNav;
//# sourceMappingURL=../../src/dist/app/useNav.js.map