// declare type DateLike = Date | string | number;

declare interface FlatArray extends Array<Value> { }

declare interface FlatObject {
    [key: string]: FlatArray | Value;
}

// declare type Key = number | string;

// declare type KeyPath = Iterable<Key>;

declare interface KeyPathMap {
    [key: string]: KeyPath;
}

// Omit type https://github.com/Microsoft/TypeScript/issues/12215#issuecomment-377567046
declare type Omit<T, K extends keyof any> = T extends any ? Pick<T, Exclude<keyof T, K>> : never;

// declare type PartialPick<T, K extends keyof T> = Partial<T> & Pick<T, K>;

declare interface SimpleArray extends Array<SimpleObject | Value> { }

declare interface SimpleObject {
    [key: string]: SimpleArray | SimpleObject | Value;
}

// declare type Value = boolean | Date | number | string; // | symbol;

/*
interface Iterator<T> {
    next(value?: any): IteratorResult<T>;
    return?(value?: any): IteratorResult<T>;
    throw?(e?: any): IteratorResult<T>;
}

declare interface Iterable<T> {
    [Symbol.iterator](): Iterator<T>;
}
*/
