var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import { GROUP } from '310-logic/component/Group';
import { useState } from 'react';
var initSelection = function (_a) {
    var select = _a.select;
    if (typeof select === 'number') {
        return [select];
    }
    if (Array.isArray(select)) {
        return select;
    }
    return [];
};
var useList = function (config) {
    var handler = useState(new WeakMap())[0];
    var _a = useState(initSelection(config)), selection = _a[0], setSelection = _a[1];
    function initStack(selection) {
        var group = config.view === 'group';
        var menu = config.view === 'menu';
        var tree = config.view === 'tree';
        var flat = !(menu || tree);
        var stack = [];
        var root = Math.max(0, group ? selection.length - 2 : selection.length - 1);
        var handlerSet = function (key /*, methods: { [key: string]: (key: string) => (e: MouseEvent) => void; }*/) {
            var handlerKey;
            var handlerSet;
            if (handler.has(handlerKey = { key: key })) {
                handlerSet = handler.get(handlerKey);
            }
            else {
                handler.set(handlerKey, handlerSet = {
                    onClick: handleClick(key, selection),
                    onMouseDown: config.handleMouseDown && handleMouseDown(key, selection)
                });
            }
            return handlerSet;
        };
        var visit = function (items, path, index, select) {
            return items.map(function (item, i) {
                var curr = path.length ? path.concat([i]) : [i];
                var key = curr.join('-');
                var active = select && index < selection.length && i === selection[index];
                switch (item.type) {
                    case GROUP: {
                        var items_1 = menu || active || (group && index < root + 1) ? visit(item.items, curr, index + 1, active) : [];
                        var itms = item.items, g = __rest(item, ["items"]);
                        var props = __assign({}, g, handlerSet(key), { active: active,
                            items: items_1,
                            key: key });
                        if (active) {
                            stack.push(props);
                        }
                        return props;
                    }
                    default:
                        return __assign({}, item, handlerSet(key), { active: active,
                            key: key });
                }
            });
        };
        var queue = [visit(config.items, [], 0, true)].concat(stack.map(function (group) { return group.items; }).reverse());
        var head = undefined;
        if (flat && stack.length) {
            if (selection.length === 0 && (group && selection.length < 2)) {
                root = 0;
            }
            else {
                root = group ? stack.length - 1 : stack.length;
                head = stack.reverse()[root - 1];
            }
        }
        return [
            queue,
            head,
            root
        ];
    }
    ;
    var _b = initStack(selection), _stack = _b[0], _head = _b[1], _root = _b[2];
    var _c = useState(_stack), stack = _c[0], setStack = _c[1];
    var _d = useState(Number(_root)), root = _d[0], setRoot = _d[1];
    var _e = useState(_head), head = _e[0], setHead = _e[1];
    function handleClick(key, selection) {
        return function (event) {
            event.preventDefault();
            event.stopPropagation();
            var group = config.view === 'group';
            var menu = config.view === 'menu';
            var tree = config.view === 'tree';
            var flat = !(menu || tree);
            var select = key.split('-').map(function (s) { return Number(s); });
            console.log('click', key, 'selection: ', selection);
            if (flat && selection.join('-').startsWith(key)) {
                console.log('go back', flat, root, key, selection.slice(0, -1));
                select = select.slice(0, -1);
                console.log('set selection', select);
            }
            /*
            if (select.length > 1) {
                config.handleClick && config.handleClick(stack[0][select[0]], event);
            } else if (select.length > 0) {
                config.handleClick && config.handleClick(stack[0][select[0]], event);
            } else {
                config.handleClick && config.handleClick(null, event);
            }
            */
            setSelection(select);
            var _a = initStack(select), _stack = _a[0], _head = _a[1], _root = _a[2];
            setStack(_stack);
            if (flat) {
                setRoot(_root);
                setHead(_head);
            }
        };
    }
    /**
     * in useNav it is used to open in another tab if event.button === 1
     **/
    function handleMouseDown(key, selection) {
        return function (event) {
            // config.handleMouseDown && config.handleMouseDown(item, index, event);
        };
    }
    return {
        head: head,
        items: stack[root]
    };
};
export default useList;
//# sourceMappingURL=../../src/dist/list/useList.js.map