var throttle = function (func, threshhold, scope) {
    if (threshhold === void 0) { threshhold = 250; }
    var last, deferTimer;
    return function () {
        var context = scope || this;
        var now = Date.now(), args = arguments;
        if (last && now < last + threshhold) {
            // hold on to it
            clearTimeout(deferTimer);
            deferTimer = window.setTimeout(function () {
                last = now;
                func.apply(context, Array(args));
            }, threshhold);
        }
        else {
            last = now;
            func.apply(context, Array(args));
        }
    };
};
export default throttle;
//# sourceMappingURL=../../src/dist/ux/throttle.js.map