import { useState, useEffect } from 'react';
import json2mq from 'json2mq';
export function useMedia(query, defaultMatches) {
    if (defaultMatches === void 0) { defaultMatches = true; }
    var _a = useState(defaultMatches), matches = _a[0], setMatches = _a[1];
    useEffect(function () {
        var mediaQueryList = window.matchMedia(typeof query === 'string' ? query : json2mq(query));
        var active = true;
        var listener = function () {
            if (!active) {
                return;
            }
            if (mediaQueryList.matches) {
                setMatches(true);
            }
            else {
                setMatches(false);
            }
        };
        mediaQueryList.addListener(listener);
        setMatches(mediaQueryList.matches);
        return function () {
            active = false;
            mediaQueryList.removeListener(listener);
        };
    }, [query]);
    return matches;
}
//# sourceMappingURL=../../src/dist/ux/useMedia.js.map