declare const PAUSE = "PAUSE";
declare const PLAY = "PLAY";
declare const PROGRESS = "PROGRESS";
declare const GO_BACKWARD = "GO_BACKWARD";
declare const GO_FORWARD = "GO_FORWARD";
declare const GO_TO = "GO_TO";
export interface SliderState {
    currentIndex: number;
    isPlaying: boolean;
    takeFocus: boolean;
}
export interface SliderActions {
    PAUSE: {
        type: typeof PAUSE;
    };
    PLAY: {
        type: typeof PLAY;
    };
    PROGRESS: {
        type: typeof PROGRESS;
    };
    GO_BACKWARD: {
        type: typeof GO_BACKWARD;
    };
    GO_FORWARD: {
        type: typeof GO_FORWARD;
    };
    GO_TO: {
        index: number;
        type: typeof GO_TO;
    };
}
export declare type SliderAction = SliderActions[keyof SliderActions];
declare function useSlider(length: number, duration: number): {
    goBackward: () => void;
    goForward: () => void;
    goTo: (index: number) => void;
    pause: () => void;
    play: () => void;
    state: SliderState;
};
export default useSlider;
